class SmallTownAI extends AIController {


   function Start();
}

function SmallTownAI::Start() {

   //set the name of our ai
   if (!AICompany.SetName("The Company")) {
      local i = 2;
      while (!AICompany.SetName("The " + i + "nd Company")) {
         i = i + 1;
      }
   }

   create_network();

   //create a loop so that our ai doesn't end
   while (true) {
      
      this.Sleep(500);
   }
}

function SmallTownAI::create_network() {

   local bus_name = null;
   //local stations_built = 0;
   local station1_tileindex = -1;
   local station2_tileindex = -1;

   //create a list of the unserviced towns between 250 and 1000 population.
   AILog.Info("Searching for a small town...");
   local town_list = AITownList();
   town_list.Valuate(AITown.GetPopulation);
   town_list.KeepAboveValue(250);
   town_list.KeepBelowValue(1000);
   AILog.Info("Number of potential towns: " + town_list.Count());
   town_list.KeepTop(1);
   AILog.Info("Town Found! Building network...");
   local town = town_list.Begin();
   local town_center = AITown.GetLocation(town);
   AISign.BuildSign(town_center, "Building Bus Network");
   AIRoad.SetCurrentRoadType(AIRoad.ROADTYPE_ROAD);

   //if towns are found, choose the smallest town and build a bus system.
   if(town_list.Count() == 1) {

      


      //code for building our station
      local stations_built = 0;
      local station1_x = -1;
      local station1_y = -1;
      local station1_front = -1;
      

      // Create a 14x14 grid around the town that will be used to find a location for a bus station.
      local station1_location = AITileList();
      station1_location.AddRectangle(town_center - AIMap.GetTileIndex(7, 7), town_center + AIMap.GetTileIndex(7, 7));

      //cut the list down to buildable tiles next to roads
      station1_location.Valuate(AITile.IsBuildable);
      station1_location.RemoveValue(0);
      station1_location.Valuate(AIRoad.GetNeighbourRoadCount);
      station1_location.RemoveValue(0);
      AILog.Info("number of potential tiles: " + station1_location.Count());

      //Create a while loop to find a spot to build a station.
      local station1 = station1_location.Begin();
      while(stations_built < 2) {

         station1_x = AIMap.GetTileX(station1);
         station1_y = AIMap.GetTileY(station1);

         //set the front of the station to a road tile adjacent to the station
         if(AIRoad.IsRoadTile(AIMap.GetTileIndex(station1_x, station1_y + 1))) {
            station1_front = AIMap.GetTileIndex(station1_x, station1_y + 1);
         } else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(station1_x, station1_y - 1))) {
            station1_front = AIMap.GetTileIndex(station1_x, station1_y - 1);
         }else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(station1_x + 1, station1_y))) {
            station1_front = AIMap.GetTileIndex(station1_x + 1, station1_y);
         }else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(station1_x - 1, station1_y))) {
            station1_front = AIMap.GetTileIndex(station1_x - 1, station1_y);
         }

         AILog.Info("Building Road between " + station1 + " and " + station1_front);
         if(AIRoad.BuildRoad(station1_front, station1)) {
            AILog.Info("Built Road between " + station1 + " and " + station1_front);
            if(AIRoad.BuildRoadStation(station1, station1_front, AIRoad.
ROADVEHTYPE_BUS,AIStation.STATION_NEW)) {
               stations_built ++;
               AILog.Info("Built Station!");

               //Mark the location of each station to order busses to stop at them.
               if(stations_built == 1) {
                  station1_tileindex = AIMap.GetTileIndex(station1_x, station1_y);
               } else if(stations_built == 2) {
                  station2_tileindex = AIMap.GetTileIndex(station1_x, station1_y);
               }
            }
            
            
            
         }else{
            station1_location.RemoveValue(station1);
         }

         
         this.Sleep(5);
         station1 = station1_location.Next();
      }
   }

   //code for building our depot
   local depot_built = false;
   local depot_x = -1;
   local depot_y = -1;
   local depot_front = -1;

   // Create a 14x14 grid around the town that will be used to find a location for a bus depot.
   local depot_location = AITileList();
   depot_location.AddRectangle(town_center - AIMap.GetTileIndex(7, 7), town_center + AIMap.GetTileIndex(7, 7));

   //cut the list down to buildable tiles next to roads
   depot_location.Valuate(AITile.IsBuildable);
   depot_location.RemoveValue(0);
   depot_location.Valuate(AIRoad.GetNeighbourRoadCount);
   depot_location.RemoveValue(0);
   AILog.Info("number of potential tiles: " + depot_location.Count());

   //Create a while loop to find a spot to build a depot.
   local depot = depot_location.Begin();
   while(!depot_built) {

      depot = depot_location.Next();
      depot_x = AIMap.GetTileX(depot);
      depot_y = AIMap.GetTileY(depot);

      //set the front of the depot to a road tile adjacent to the depot
      if(AIRoad.IsRoadTile(AIMap.GetTileIndex(depot_x, depot_y + 1))) {
         depot_front = AIMap.GetTileIndex(depot_x, depot_y + 1);
      } else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(depot_x, depot_y - 1))) {
         depot_front = AIMap.GetTileIndex(depot_x, depot_y - 1);
      }else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(depot_x + 1, depot_y))) {
         depot_front = AIMap.GetTileIndex(depot_x + 1, depot_y);
      }else if(AIRoad.IsRoadTile(AIMap.GetTileIndex(depot_x - 1, depot_y))) {
         depot_front = AIMap.GetTileIndex(depot_x - 1, depot_y);
      }
      AILog.Info("Building Road between " + depot + " and " + depot_front);
      if(AIRoad.BuildRoad(depot_front, depot)) {
         AILog.Info("Built Road between " + depot + " and " + depot_front);
         if(AIRoad.BuildRoadDepot(depot, depot_front)) {
            depot_built = true;
            AILog.Info("Built Depot!");
         }

          
      }else{
         depot_location.RemoveValue(depot);
      }
      this.Sleep(5);
   }
   
   //chose a road vehicle to go between our two bus stations.
   local engines = AIEngineList(AIVehicle.VT_ROAD);
   engines.Valuate(AIEngine.IsValidEngine);
   engines.RemoveValue(0); 
   engines.Valuate(AIEngine.GetCargoType);
   engines.RemoveValue(AICargo.CC_PASSENGERS);
   AILog.Info("Number of potential engines: " + engines.Count());
   while(engines.Count() > 1) {
      engines.RemoveTop(1);
      this.Sleep(5);
   }

   local bus = null;
   //build the vehicle
   local bus_type = engines.Begin();
   if(AIEngine.IsBuildable(bus_type)) {
      AILog.Info("Bus found: " + bus_type + "  Building at" + depot);
      bus = AIVehicle.BuildVehicle(depot, bus_type);
      AILog.Info("Built Bus!");
   }

   //give the vehicles its orders
   AILog.Info("ordering bus " + bus + " to go to: " + station1_tileindex);
   if(AIOrder.InsertOrder(bus, 0, station1_tileindex, AIOrder.OF_NONE)) {
      AILog.Info("Bus order 1 set");
   }
   if(AIOrder.InsertOrder(bus, 1, station2_tileindex, AIOrder.OF_NONE)) {
      AILog.Info("Bus order 2 set");
   }

   //Finally, start the bus.
   AILog.Info("Bus network complete, starting bus transport!");
   AIVehicle.StartStopVehicle(bus);
}
